#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "hdparm.h"

int verbose = 0;
int mode;
static __u8 last_identify_op = 0;

static void *get_identify_data (int fd, void *prev)
{
	static __u8 args[4+512];
	__u16 *id = (void *)(args + 4);
	int i;

	if (prev != (void *)-1)
		return prev;
	memset(args, 0, sizeof(args));
	last_identify_op = ATA_OP_IDENTIFY;
	args[0] = last_identify_op;
	args[3] = 1;
	if (do_drive_cmd(fd, args)) {
		last_identify_op = ATA_OP_PIDENTIFY;
		args[0] = last_identify_op;
		args[1] = 0;
		args[2] = 0;
		args[3] = 1;
		if (do_drive_cmd(fd, args)) {
			//perror(" HDIO_DRIVE_CMD(identify) failed");
			return NULL;
		}
	}
	/* byte-swap the little-endian IDENTIFY data to match byte-order on host CPU */
	//for (i = 0; i < 0x100; ++i)
	//	__le16_to_cpus(&id[i]);
	return id;
}


static const char *name [MODE_ATACB2+1] = {
	"SAT",
	"ATACB",
	"ATACB2",
};
int  main(int argc, char **argv)
{
	int fd;
	void *id;
	if (argc != 2 && argc != 3) {
		printf("help : %s [-v] device_name\n", argv[0]);
		return 1;
	}
	if (strcmp(argv[1], "-v") == 0) {
		verbose = 1;
		argv++;
	}

	fd = open(argv[1], O_RDWR);
	if (fd == -1) {
		printf("can't open %s\n", argv[1]);
		return 2;
	}

	for (mode = MODE_SAT; mode <= MODE_ATACB2; mode++) {
		id = get_identify_data(fd, -1);
		printf("%s : ", name[mode]);
		if (id)
			printf("OK\n");
		else
			printf("KO\n");
	}

	return 0;
}


